#include "testlib.h"
#include <vector>
#include <algorithm>
#include <iostream>
#include <string>
#include <set>

using namespace std;

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
	int score = 0;
	int tests = inf.readInt();
	for (int testno = 0; testno < tests; ++testno) {
		int n = inf.readInt();
		vector <vector <int>> a(n), b(n), c(n);
		for (int i = 0; i < n; ++i) {
			a[i].resize(n, 0);
			b[i].resize(n, 0);
			c[i].resize(n, 0);
			for (int j = 0; j < n; ++j) {
				b[i][j] = inf.readInt(0, 1);
				a[i][j] = ouf.readInt(0, 1);
			}
		}
		bool flag = true;
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				for (int k = 0; k < n; ++k) {
					c[i][j] += a[i][k] * a[k][j];
				}
				c[i][j] %= 2;
				if (c[i][j] != b[i][j]) {
					flag = false;
				}
			}
		}
		if (flag) score += 2;
	}
    quitp(score, "participant's solution is ok");
    //quitf(_ok, "Accepted for testing");
    return 0;
}
