#include <algorithm>
#include <cstdio>
#include <queue>
#include <map>

using namespace std;

#define N 100005

int n, k, i;
map<int, int> cnt;
priority_queue<int> q;
int a[N];

int main()
{
	scanf("%d%d", &n, &k);
	for (i = 0; i < n; i++)
		scanf("%d", &a[i]);
	for (i = 0; i < k; i++)
		cnt[a[i]]++;
	for (i = 0; i < k; i++)
		if (cnt[a[i]] == 1)
			q.push(a[i]);
	printf("%d\n", q.top());
	for (i = k; i < n; i++)
	{
		cnt[a[i - k]]--;
		cnt[a[i]]++;
		q.push(a[i - k]);
		q.push(a[i]);
		while (!q.empty() && cnt[q.top()] != 1)
			q.pop();
		if (q.empty())
			printf("-1\n"); else
			printf("%d\n", q.top());
	}
	return 0;
}
