import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.HashMap;
import java.util.TreeSet;
 
public class Main {
	private static StreamTokenizer in = new StreamTokenizer(new BufferedReader(
			new InputStreamReader(System.in)));
	private static PrintWriter out = new PrintWriter(System.out);
 
	private static int nextInt() throws Exception {
		in.nextToken();
		return (int) in.nval;
	}
 
	private static String nextString() throws Exception {
		in.nextToken();
		return in.sval;
	}
 
	public static void main(String[] args) throws Exception {
		int n = nextInt(), k = nextInt();
		TreeSet<Integer> min = new TreeSet<Integer>();
		HashMap<Integer, Integer> col = new HashMap<Integer, Integer>();
		int[] a = new int[n];
		for (int i=0, p=0; i<n; i++) {
			a[i] = nextInt();
		}
		
		for (int i=0; i<k; i++) {
			if (!col.containsKey(a[i])) {
				col.put(a[i], 1);
				min.add(a[i]);
			} else {
				int u = col.get(a[i]);
				col.put(a[i], u + 1);
				if (u == 1) {
					min.remove(a[i]);
				}
			}
		}
		
		out.println(min.size() > 0 ? min.last() : "Nothing");
		
		for (int offset=0; offset<n-k; offset++) {
			int last = offset + k;
			if (col.get(a[offset]) == 1) {
				min.remove(a[offset]);
			}
			col.put(a[offset], col.get(a[offset]) - 1);
			if (col.get(a[offset]) == 1) {
				min.add(a[offset]);
			}
			
			
			if (!col.containsKey(a[last])) {
				col.put(a[last], 1);
				min.add(a[last]);
			} else {
				int u = col.get(a[last]);
				col.put(a[last], u + 1);
				if (u == 1) {
					min.remove(a[last]);
				}
			}
			
			out.println(min.size() > 0 ? min.last() : "Nothing");
		}
		
		out.flush();
	}
}
